/* Daylighting Visualization Slider */

//int maxImages = 12;
int maxImagesDAY = 13;
int maxImagesMON = 3;
int imageIndex = 0;

PImage[][] images = new PImage[maxImagesMON][maxImagesDAY];
PFont font;

String time[];
String month[];

HScrollbar Hslider;
HScrollbar Hslider2;

void setup() {
  size(800,775);
  noStroke();
//  font = createFont("NewsCycle-Bold", 32);
// font = loadFont("MyriadPro-BoldIt-48.vlw");
//  textFont(font); 
  

  color sliderColor = color(#f2f2f2);

  time = loadStrings("6to6.csv");
  month = loadStrings("juneseptdec.csv");

  
  for (int i = 0; i < maxImagesDAY; i++) {
    for (int x = 0; x < maxImagesMON; x++){
      images[x][i] = loadImage( x + "." + nf(i, 2) + ".png" );   
    }
  }

Hslider = new HScrollbar(30, height-30, width-200, 20, 1, maxImagesDAY-1, sliderColor); 
Hslider2 = new HScrollbar(width-170-90, height-70, 90, 20, 1, maxImagesMON-1, sliderColor);
Hslider.setValue(0);
Hslider2.setValue(0);
}
    

void draw() {
  background(20);
  image(images[Hslider2.value()][Hslider.value()], 0, 0);
  
  fill(255);
  textSize(18);
  textAlign(RIGHT);
  text(time[Hslider.value()], width-30, height-25);
  text(month[Hslider2.value()], width-30, height-65);
  
  textAlign(LEFT);
  text("151120 Deerfield Academy: Shadow Study - Field", 30, height-65); //text for images3
  
Hslider.update();
Hslider.display();

Hslider2.update();
Hslider2.display();
  
    }

class HScrollbar {
  int swidth, sheight;    // width and height of bar
  float xpos, ypos;       // x and y position of bar
  float spos, newspos;    // x position of slider
  float sposMin, sposMax; // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  int step;
  color barcol;

  HScrollbar (float xp, float yp, int sw, int sh, int l, int st, color colbac) {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos + swidth/2 - sheight/2;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
    step = st;
    barcol = colbac;
  }

  void update() {
    if (overEvent()) {
      over = true;
    } else {
      over = false;
    }
    if (mousePressed && over) {
      locked = true;
    }
    if (!mousePressed) {
      locked = false;
    }
    if (locked) {
      newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
    }
    if (abs(newspos - spos) > 1) {
      spos = spos + (newspos-spos)/loose;
    }
  }

  float constrain(float val, float minv, float maxv) {
    return min(max(val, minv), maxv);
  }

  boolean overEvent() {
    if (mouseX > xpos && mouseX < xpos+swidth &&
       mouseY > ypos && mouseY < ypos+sheight) {
      return true;
    } else {
      return false;
    }
  }

  void display() {
    noStroke();
    fill(barcol);
    rect(xpos, ypos, swidth, sheight);
    if (over || locked) {
      fill(#efb22d);
    } else {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
  }

  float getPos() {
    // Convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
  
  int value() {
    // Convert slider position Spos to a value between 0 and 1
    return round((spos-xpos) / (swidth-sheight) * step);
  }
  
  void setValue(float value)
  {
    // convert a value (0 to 1) to slider position
    if (value<0) value=0;
    if (value>1) value=1;
    spos = xpos + ((swidth-sheight)*value);
    newspos = spos;
  }
}


